<?php
// Main admin page
global $wpdb;

// Defaults
$max_desc = 400;

// Is the registartion done?
$registered = false;
$reg_data = stepbox_registered();
if($reg_data) {
	if($reg_data['jvzoo_id']) {
		$registered = true;
	}
}

// Default whitelist page
$default_whitelist_link = get_option('stepbox_whitelist_page');

// Form submitted
if($_POST['sb_name'] || $_POST['sb_saved_id']) {
	$_POST = stripslashes_deep($_POST);

	$bg_color = ($_POST['sb_bgcolor_type'] == 'color')? $_POST['sb_bgcolor'] : null;
	$box_bg_color = ($_POST['sb_step_bgcolor_type'] == 'color')? $_POST['sb_step_bgcolor'] : null;
	$sb_options = array(
		'sb_bgcolor' => $bg_color,
		'sb_title_size' => $_POST['sb_title_size'],
		'sb_title_text' => $_POST['sb_title_text'],
		'sb_title_color' => $_POST['sb_title_color'],
		'sb_step_bgcolor' => $box_bg_color,
		'sb_step_title_size' => $_POST['sb_step_title_size'],
		'sb_step_title_color' => $_POST['sb_step_title_color'],
		'sb_desc_size' => $_POST['sb_desc_size'],
		'sb_desc_color' => $_POST['sb_desc_color'],
		'sb_btn1_size' => $_POST['sb_btn1_size'],
		'sb_btn1_color' => $_POST['sb_btn1_color'],
		'sb_btn1_font_color' => $_POST['sb_btn1_font_color'],
		'sb_btn2_size' => $_POST['sb_btn2_size'],
		'sb_btn2_color' => $_POST['sb_btn2_color'],
		'sb_btn2_font_color' => $_POST['sb_btn2_font_color'],
		'sb_btn3_size' => $_POST['sb_btn3_size'],
		'sb_btn3_color' => $_POST['sb_btn3_color'],
		'sb_btn3_font_color' => $_POST['sb_btn3_font_color'],
		'sb_border_width' => $_POST['sb_border_width'],
		'sb_border_color' => $_POST['sb_border_color'],
		'sb_border_style' => $_POST['sb_border_style'],
	);
	
	// Bonus 
	list($ext_type,$ext_id) = explode('_', $_POST['sb_bonus_id']);
	if($ext_id == 99999) {
		$bonus_id = 99999;
	} else {
		$bonus_id = $wpdb->get_var("SELECT id FROM ". STEPBOX_BONUS_TABLE ." WHERE external_id='$ext_id' AND external_type='$ext_type'");
	}
	
	$data = array( 
		'stepbox_options' => serialize($sb_options),
		'stepbox_title' => $_POST['sb_title'],
		'step1_title' => $_POST['sb_step1_title'],
		'step2_title' => $_POST['sb_step2_title'],
		'step3_title' => $_POST['sb_step3_title'],
		'step1_desc' => $_POST['sb_step1_desc'],
		'step2_desc' => $_POST['sb_step2_desc'],
		'step3_desc' => $_POST['sb_step3_desc'],
		'bonus_id' => $bonus_id,
		'email' => $_POST['sb_email'],
		'email_type' => $_POST['sb_email_type'],
		'stepbox_layout' => $_POST['stepbox_layout'],
		'fb_url' => $_POST['sb_fb_url'],
		'custom_bonus_url' => $_POST['sb_bonus_custom_url'],
	);
	
	// Custom email 
	// Default images
	$email_image = array(
	'gmail'=> STEPBOX_PLUGIN_URL . 'images/gmail.png',
	'yahoo'=> STEPBOX_PLUGIN_URL . 'images/yahoo.png',
	'hotmail'=> STEPBOX_PLUGIN_URL . 'images/hotmail.png',
	'aol'=> STEPBOX_PLUGIN_URL . 'images/aol.png',
	);
	if($_POST['sb_email_type'] == 'custom') {
		// No pages has been created/tied yet
		if(!$_POST['sb_email_page_id']) {	
			$sb_email_array = array('gmail','hotmail','yahoo','aol','other');
			
			// Prepare content and upload images if any
			foreach($sb_email_array as $e) {
				$image_var = 'sb_' . $e . '_image';
				// Upload icon
				if ($_FILES[$image_var]['tmp_name']) {
					$uploadedfile = $_FILES[$image_var];
					$upload_overrides = array( 'test_form' => false );
					$movefile = wp_handle_upload($uploadedfile, $upload_overrides);
					if($movefile) {
						$email_img[$e] = $movefile['url'];
					}
				// Use the default
				} else {
					$email_img[$e] = $email_image[$e];
				}
				$content_var = 'sb_' . $e . '_inst';
				$email_data[$e] = $_POST[$content_var];
			}
			$email_data['sb_email_inst'] = $_POST['sb_email_inst'];
			$whitelist_page_id = stepbox_create_email_page($email_data, $email_img);
			$data['email_page_id'] = $whitelist_page_id;
		}
	}
	
	// Approved bonuses
	if($_POST['sb_approved']) {
		$sb_approved = implode(',', $_POST['sb_approved']);
		$table_name = STEPBOX_BONUS_TABLE;
		$wpdb->query("
			UPDATE $table_name
			SET approved = 0
			WHERE id NOT IN ($sb_approved)
		");
		$wpdb->query("
			UPDATE $table_name
			SET approved = 1
			WHERE id IN ($sb_approved)
		");
	}
	
	if ( ! function_exists( 'wp_handle_upload' ) ) require_once( ABSPATH . 'wp-admin/includes/file.php' );
	
	// icons
	for($i = 1; $i<=3; $i++) {
		$remove_var = 'remove_step' . $i . '_icon_image';
		$icon_var = 'sb_step' . $i . '_icon_image';
		$icon_var2 = 'step' . $i . '_icon_image';
		// Upload icon
		if ($_FILES[$icon_var]['tmp_name']) {
			$uploadedfile = $_FILES[$icon_var];
			$upload_overrides = array( 'test_form' => false );
			$movefile = wp_handle_upload($uploadedfile, $upload_overrides);
			if($movefile) {
				$data[$icon_var2] = $movefile['url'];
			}
		// Remove icons
		} else if($_POST[$remove_var]) {
			$data[$icon_var2] = null;
		}
	}
	
	// buttons
	for($i = 1; $i<=3; $i++) {
		$remove_var = 'remove_step' . $i . '_button_image';
		$button_var = 'sb_step' . $i . '_button_image';
		$button_var2 = 'step' . $i . '_button_image';
		// Upload button
		if ($_FILES[$button_var]['tmp_name']) {
			$uploadedfile = $_FILES[$button_var];
			$upload_overrides = array( 'test_form' => false );
			$movefile = wp_handle_upload($uploadedfile, $upload_overrides);
			if($movefile) {
				$data[$button_var2] = $movefile['url'];
			}
		// Remove buttons
		} else if(isset($_POST[$remove_var])) {
			$data[$button_var2] = null;
		}
	}

	// Incomplete data?
	$stepbox_status = 'active';
	if(!$_POST['sb_bonus_id'] || ($_POST['sb_bonus_id']== 'custom_99999' && !$_POST['sb_bonus_custom_url'])) {
		$stepbox_status = 'inactive';
	} 
	if(!$_POST['sb_fb_url']) {
		$stepbox_status = 'inactive';
	}

	// New 
	if($_POST['sb_name']) {
		$sb_code = preg_replace('/\s/', '_', strtolower($_POST['sb_name']));
		$sb_code = preg_replace('/\W/', '', $sb_code);
		$code_check = false;
		//Make sure no dupliate code exists
		while(!$code_check) {
			$exists = $wpdb->get_row("SELECT stepbox_code FROM ". STEPBOX_MAIN_TABLE ." WHERE stepbox_code='$sb_code'", ARRAY_A);
			if($exists['stepbox_code']) {
				$sb_code .= 'x';
			} else {
				$code_check = true;
			}
		}
		
		$data['stepbox_name'] = $_POST['sb_name']; 
		$data['stepbox_code'] = $sb_code;
		$data['stepbox_status'] = $stepbox_status;
		$data['created_date'] = date('Y-m-d H:i:s');
		
		$wpdb->insert( 
			STEPBOX_MAIN_TABLE, 
			$data
		);
		$newid = $wpdb->insert_id;
		
		//Save for preview
		$json = json_encode($data);
		$perview_existing = get_option('stepbox_preview_' . $newid);
		if($perview_existing) {
			delete_option('stepbox_preview_' . $newid);
		}
		add_option('stepbox_preview_' . $newid, $json);
		
		// Reload the newly saved page
		echo '<script>';
		echo 'window.location.href = "' . admin_url("?page=stepbox&tid=1&stepbox_id=$newid") . '";';
		echo '</script>';
		exit;

	// Edit 
	} else {
		$data['stepbox_status'] = $stepbox_status;
		
		$wpdb->update( 
			STEPBOX_MAIN_TABLE, 
			$data,
			array('id'=>$_POST['sb_saved_id'])
			);
			
		$data = $wpdb->get_row("SELECT * FROM " . STEPBOX_MAIN_TABLE . " WHERE id=" . $_POST['sb_saved_id'], ARRAY_A);
		//Save for preview
		$json = json_encode($data);
		$perview_existing = get_option('stepbox_preview_' . $data['id']);
		if($perview_existing) {
			delete_option('stepbox_preview_' . $data['id']);
		}
		add_option('stepbox_preview_' . $data['id'], $json);
	}
	$saved = '<span class="save-msg" style="padding-left:15px; color: #3bb83f; font-weight: bold;">Stepbox was Saved Successfully</span>';
}

// Load the default data
include(STEPBOX_PLUGIN_DIR . '/data/stepbox-default-data.php');

// Custom email 
// Default images
$email_image = array(
	'gmail'=> STEPBOX_PLUGIN_URL . 'images/gmail.png',
	'yahoo'=> STEPBOX_PLUGIN_URL . 'images/yahoo.png',
	'hotmail'=> STEPBOX_PLUGIN_URL . 'images/hotmail.png',
	'aol'=> STEPBOX_PLUGIN_URL . 'images/aol.png',
);


// Load the saved data
if($_GET['stepbox_id'] && is_numeric($_GET['stepbox_id'])) {
	$sid = $_GET['stepbox_id'];
	$main_data = $wpdb->get_row("SELECT * FROM " . STEPBOX_MAIN_TABLE . " WHERE id=$sid", ARRAY_A);
	$options = unserialize($main_data['stepbox_options']);
	$options['email_inst'] = $stepbox['email_inst'];
	$options['gmail_inst'] = $stepbox['gmail_inst'];
	$options['yahoo_inst'] = $stepbox['yahoo_inst'];
	$options['aol_inst'] = $stepbox['aol_inst'];
	$options['hotmail_inst'] = $stepbox['hotmail_inst'];
	$stepbox = array_merge($main_data, $options);
}

// Load the saved stepbox data
$saved_sb = $wpdb->get_results("SELECT * FROM " . STEPBOX_MAIN_TABLE . " ORDER BY stepbox_name", ARRAY_A);

// Updates available?
$sb_update = false;
$upd_check = get_option('stepbox_update_check');
if($upd_check) {
	if(is_object($upd_check->update)) {
		$sb_current = STEPBOX_VERSION;
		$sb_new = $upd_check->update->version;
		if($sb_current < $sb_new) {
			$sb_update = true;
		}
	}
}

// Which tab to load
$init_tab = ($registered)? '{ active: 1 }' : '';

if($_GET['tid']) {
	$init_tab = "{ active: {$_GET['tid']} }";
}

// WP version
$version =  get_bloginfo('version');
$version = preg_replace('/(\d+\.\d+).+/', "$1", $version);
?>

<script>
jQuery(document).ready(function($) {
	$("#stepbox-admin-tabs").tabs(<?php echo $init_tab;?>);  
	$("#stepbox-admin-tabs").show();
	
	<?php if($sb_update) :?>  
		$("li.last a").click(function() {
			window.location.href = '<?php echo admin_url('plugins.php');?>';
		});
	<?php endif ?>
	
	$(".save-button").click(function(evt) {
		var formAction = '<?php echo admin_url('?page=stepbox');?>';
		formAction += '&tid=' + $("#stepbox-admin-tabs").tabs("option","active"); 
		
		if($("#sb_saved_id").val() > 0) {
			// ID selected
			formAction += '&stepbox_id=' + $('#sb_saved_id').val();
		} else {
			if($("#sb_name").val() == '') {
				alert('Stepbox Name is required');
				$("#stepbox-admin-tabs").tabs({active: 1});
				return false;
			}
		}
		
		if($("input:radio[name=sb_bonus_id]:checked").val() == 'custom_99999' &&  $("#sb_bonus_custom_url").val() == '') {
			alert('URL for your bonus training in Step 2 is required');
			$("#stepbox-admin-tabs").tabs({active: 3});
			return false;
		}
		
		if($("#sb_fb_url").val() == '') {
			alert('Facebook Group URL in Step 3 is required');
			$("#stepbox-admin-tabs").tabs({active: 4});
			return false;
		}
		
		$("#stepbox_form").attr('action',formAction);
		$("#stepbox_form").submit();
	});
	
	$('#stepbox_form :input').change(function(){
		if($(this).hasClass('no-modify-check') === false) {
			$('.save-msg').attr('style', 'color: #d61a1a; padding-left:15px; font-weight: bold;');
			$('.save-msg').text('Stepbox modified');
		}
	});
	$(".fancybox").fancybox();
});
</script>

<div>
<h3>Stepbox Settings: <?php echo($stepbox['stepbox_name'])? "'" . $stepbox['stepbox_name'] . "'" : 'Create New Stepbox';?>
 <?php echo ($saved)? $saved : '<span class="save-msg"></span>';?>
</h3>
</div>

<div id="stepbox-admin-tabs" style="display:none;">
	<ul>
		<li><a href="#stepbox-admin-tab-13">Registration</a></li>
		<li><a href="#stepbox-admin-tab-11">Main</a></li>
		<li><a href="#stepbox-admin-tab-1">Step 1</a></li>
		<li><a href="#stepbox-admin-tab-2">Step 2</a></li>
		<li><a href="#stepbox-admin-tab-3">Step 3</a></li>
		<li><a href="#stepbox-admin-tab-4">Generate</a></li>
		<?php if($sb_update) :?>
			<li class="sb-update last"><a href="#stepbox-admin-tab-12">UPDATES AVAILABLE</a></li>
		<?php endif ?>
	</ul>

	<div id="stepbox-admin-tab-13">
		<?php include('stepbox-admin-reg-form.php'); ?>
	</div>

<form id="stepbox_form" method="POST" enctype="multipart/form-data">
	<div id="stepbox-admin-tab-11">
		<?php include('stepbox-admin-main-tab.php'); ?>
	</div>
	<div id="stepbox-admin-tab-1">
		<?php include('stepbox-admin-step1-tab.php'); ?>
	</div>
	<div id="stepbox-admin-tab-2">
		<?php include('stepbox-admin-step2-tab.php'); ?>
	</div>
	<div id="stepbox-admin-tab-3">
		<?php include('stepbox-admin-step3-tab.php'); ?>
	</div>
</form>

	<div id="stepbox-admin-tab-4">
		<?php include('stepbox-admin-generate-tab.php'); ?>
	</div>
	
	<?php if($sb_update) :?>
	<div id="stepbox-admin-tab-12">Please wait...</div>
	<?php endif ?>
	
</div>


